Index: binaries/data/mods/public/simulation/data/settings/player_defaults.json
===================================================================
--- binaries/data/mods/public/simulation/data/settings/player_defaults.json	(revision 18167)
+++ binaries/data/mods/public/simulation/data/settings/player_defaults.json	(working copy)
@@ -11,7 +11,7 @@
 		{
 			"Name": "Player 1",
 			"Civ": "athen",
-			"Color": { "r": 46, "g": 46, "b": 200 },
+			"Color": { "r": 21, "g": 55, "b": 149 },
 			"AI": "",
 			"AIDiff": 3
 		},
@@ -25,7 +25,7 @@
 		{
 			"Name": "Player 3",
 			"Civ": "gaul",
-			"Color": { "r": 50, "g": 165, "b": 5 },
+			"Color": { "r": 86 , "g": 153, "b": 31 },
 			"AI": "petra",
 			"AIDiff": 3
 		},
@@ -32,7 +32,7 @@
 		{
 			"Name": "Player 4",
 			"Civ": "iber",
-			"Color": { "r": 230, "g": 230, "b": 75 },
+			"Color": { "r": 231, "g": 200, "b": 5 },
 			"AI": "petra",
 			"AIDiff": 3
 		},
@@ -53,7 +53,7 @@
 		{
 			"Name": "Player 7",
 			"Civ": "pers",
-			"Color": { "r": 235, "g": 120, "b": 20 },
+			"Color": { "r": 205, "g": 115, "b": 16 },
 			"AI": "petra",
 			"AIDiff": 3
 		},
@@ -60,7 +60,7 @@
 		{
 			"Name": "Player 8",
 			"Civ": "rome",
-			"Color": { "r": 64, "g": 64, "b": 64 },
+			"Color": { "r": 28, "g": 28, "b": 28 },
 			"AI": "petra",
 			"AIDiff": 3
 		}
Index: binaries/data/mods/public/simulation/templates/template_gaia_flora_bush_berry.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_gaia_flora_bush_berry.xml	(revision 18167)
+++ binaries/data/mods/public/simulation/templates/template_gaia_flora_bush_berry.xml	(working copy)
@@ -8,12 +8,12 @@
     <GenericName>Bush</GenericName>
     <SpecificName>Berries</SpecificName>
     <Tooltip>Gather the fruit from these bushes to accumulate Food.</Tooltip>
-    <History>Gathering berries is done by many primates, and was also a primary food source in prehistoric times. But due to agriculture and livestock breeding, it only served as supplementary food source in the ancient world.</History>
+    <History>Berries are tasty, fruity, and scrunchiously crunchable.</History>
     <Icon>gaia/flora_bush_berry.png</Icon>
   </Identity>
   <Minimap>
     <Type>food</Type>
-    <Color r="205" g="115" b="16"/>
+    <Color r="155" g="204" b="102"/>
   </Minimap>
   <ResourceSupply>
     <KillBeforeGather>false</KillBeforeGather>
Index: binaries/data/mods/public/simulation/templates/template_gaia_geo_mineral.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_gaia_geo_mineral.xml	(revision 18167)
+++ binaries/data/mods/public/simulation/templates/template_gaia_geo_mineral.xml	(working copy)
@@ -8,7 +8,7 @@
   </Identity>
   <Minimap>
     <Type>metal</Type>
-    <Color r="192" g="192" b="0"/>
+    <Color r="206" g="82" b="6"/>
   </Minimap>
   <ResourceSupply>
     <KillBeforeGather>false</KillBeforeGather>
Index: binaries/data/mods/public/simulation/templates/template_gaia_geo_rock.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_gaia_geo_rock.xml	(revision 18167)
+++ binaries/data/mods/public/simulation/templates/template_gaia_geo_rock.xml	(working copy)
@@ -8,7 +8,7 @@
   </Identity>
   <Minimap>
     <Type>stone</Type>
-    <Color r="128" g="128" b="128"/>
+    <Color r="170" g="170" b="170"/>
   </Minimap>
   <ResourceSupply>
     <KillBeforeGather>false</KillBeforeGather>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna.xml	(revision 18167)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna.xml	(working copy)
@@ -16,7 +16,7 @@
   <Loot disable=""/>
   <Minimap>
     <Type>food</Type>
-    <Color b="30" g="70" r="115"/>
+    <Color b="141" g="141" r="227"/>
   </Minimap>
   <ResourceGatherer disable=""/>
   <UnitAI>